//--------------------------------------

$InvList[JetPack] = 1;
$RemoteInvList[JetPack] = 1;

//--------------------------------------

ItemImageData JetPackImage
{
	shapeFile = "mortargun";
	mountPoint = 2;
	weaponType = 2;  // Sustained
	minEnergy = 1;
	maxEnergy = 8.5;   // Energy used/sec for sustained weapons
  	mountOffset = { 0, 0, 0.31 };
  	mountRotation = { 5, 0, 3 };
	firstPerson = false;

	lightType = 3;  // Weapon Fire
	lightRadius = 15;
	lightTime = 2;
	lightColor = { 1, 1, 0.2 };
	sfxFire = SoundFlyerIdle;
};

ItemData JetPack
{
	description = "Jet Pack";
	shapeFile = "mortargun";
	className = "Backpack";
      heading = "kBackpacks";
	shadowDetailMask = 4;
	imageType = JetPackImage;
	price = 2000;
	hudIcon = "energypack";
	showWeaponBar = true;
	hiliteOnActive = true;
};

function JetPack::onUnmount(%player,%item,$BackPackSlot)
{
	if (Player::getMountedItem(%player,$WeaponSlot) == JetGun)
		Player::unmountItem(%player,$WeaponSlot);
}

function JetPack::onUse(%player,%item)
{
	if (Player::getMountedItem(%player,$BackpackSlot) != %item)
		Player::mountItem(%player,%item,$BackpackSlot);
	else
	{
		Player::trigger(%player,$BackpackSlot,true);
		Player::mountItem(%player,JetGun,$WeaponSlot);
	}
}

function JetPackImage::onActivate(%player,%imageSlot)
{
	Client::sendMessage(Player::getClient(%player),0,"Jetpack On"); // hehe :)
	%player.hasJetpack = true;
	TSR::JetPack(%player);
}

function TSR::JetPack(%player)
{
	if(%player.hasJetpack)	// Keep him there; negate the gravity effect
	{
		if(Player::isTriggered(%player,$WeaponSlot)) // Only if the trigger is on
		{
			if(Player::getMountedItem(%player,$WeaponSlot) == JetGun) // Incoming MATH BLASTER! AAAAAA!!
			{
				%trans = GameBase::getMuzzleTransform(%player);
				%c1 = getWord(getBoxCenter(%player), 0);
				%c2 = getWord(getBoxCenter(%player), 1);
				%c3 = getWord(getBoxCenter(%player), 2) + 0.125;
				%middle = %c1@" "@%c2@" "@%c3;
				%center = "0 0 1 0 0 0 0 0 1 " @ %middle; 
				%rot = GameBase::getRotation(%player);
				%zrot = getWord(%trans,5);
				%kick = Vector::getFromRot(%rot,$Jet::Speed,%zrot*10); // Sensitive :)
				%xkick = getWord(%kick, 0);
				%ykick = getWord(%kick, 1);
				%zkick = getWord(%kick, 2); 

				if(%zkick > 8.75)
					%vel = "0 0 "@%zkick + 5;
				else if(%zkick < -8.75)
					%vel = "0 0 "@%zkick - 5;
				else 
					%vel = %xkick@" "@%ykick@" "@%zkick; // New way of looking at velocity

				Item::setVelocity(%player, %vel);

				if(%player.smokeCount >= 15)
				{
					Projectile::spawnProjectile(PassiveSmoke,%center,%player,%vel);
					Projectile::spawnProjectile(ActiveSmoke,%center,%player,%vel);
					%player.smokeCount = 0;
				}
			}
		}
		else
		{
			Item::setVelocity(%player, "0 0 "@$Jet::HoverValue); // $Jet::HoverValue being the universal constanst taking place from the earlier float pack
			%player.jetActive = false;

			if(%player.smokeCount >= 15)
			{
				Projectile::spawnProjectile(PassiveSmoke,%center,%player,%vel);
				%player.smokeCount = 0;
			}
		}

		%player.smokeCount += 1;
		schedule("TSR::JetPack("@%player@");", 0.01, %player); // Only 100x a second...
	}
}

function JetPackImage::onDeactivate(%player,%imageSlot)
{
	Client::sendMessage(Player::getClient(%player),0,"Jetpack Off");
	Player::trigger(%player,$BackpackSlot,false);
	%player.hasJetpack = false; // Strings in place to keep a const int on pack activation

	if(Player::getMountedItem(%player,$WeaponSlot) == JetGun)
		Player::unmountItem(%player,$WeaponSlot);
}

function JetPack::onDrop(%player,%item)
{
	if($matchStarted)
	{
		%mounted = Player::getMountedItem(%player,$WeaponSlot);

		if (%mounted == JetGun)
			Player::unmountItem(%player,$WeaponSlot);
		else
			Player::mountItem(%player,%mounted,$WeaponSlot);

		Item::onDrop(%player,%item);
	}
}

