//--------------------------------------

$AutoUse[Mortar] = True;
$SellAmmo[MortarAmmo] = 5;
$AmmoPackMax[MortarAmmo] = 10;
$AmmoPackItems[6] = MortarAmmo;
$WeaponAmmo[Mortar] = Mortar;

//--------------------------------------

$InvList[Mortar] = 1;
$InvList[MortarAmmo] = 1;
$RemoteInvList[Mortar] = 1;
$RemoteInvList[MortarAmmo] = 1;

//--------------------------------------

GrenadeData MortarShell1
{
   bulletShapeName    = "armorKit.dts";
   explosionTag       = MortarShellExp;
   collideWithOwner   = True;
   ownerGraceMS       = 250;
   collisionRadius    = 0.3;
   mass               = 5.0;
   elasticity         = 0.01;

   damageClass        = 1;       // 0 impact, 1, radius
   damageValue        = 1.0;
   damageType         = $MortarDamageType;

   explosionRadius    = 20.0;
   kickBackStrength   = 250.0;
   maxLevelFlightDist = 275;
   totalTime          = 30.0;
   liveTime           = 0;
   projSpecialTime    = 0.01;

   inheritedVelocityScale = 0.5;
   smokeName              = "smoke.dts";
};

GrenadeData MortarShell2
{
   bulletShapeName    = "grenade.dts";
   explosionTag       =  debrisExpLarge;
   collideWithOwner   = True;
   ownerGraceMS       = 250;
   collisionRadius    = 0.3;
   mass               = 5.0;
   elasticity         = 0.01;

   damageClass        = 1;       // 0 impact, 1, radius
   damageValue        = 0;
   damageType         = $MortarDamageType;

   explosionRadius    = 20.0;
   kickBackStrength   = 250.0;
   maxLevelFlightDist = 275;
   totalTime          = 30.0;
   liveTime           = 0;
   projSpecialTime    = 0.01;

   inheritedVelocityScale = 0.5;
   smokeName              = "mortartrail.dts";
};

$BulletToWeapon[MortarShell1] = Mortar;
$BulletToWeapon[MortarShell2] = Mortar;

//--------------------------------------

ItemData MortarAmmo
{
	description = "Mortar Ammo";
	className = "Ammo";
   heading = "xAmmunition";
	shapeFile = "mortarammo";
	shadowDetailMask = 4;
	price = 5;
};

ItemImageData MortarImage
{
	shapeFile = "mortargun";
	mountPoint = 0;
	mountOffset = { 0, 0.8, 0.1 }; //-  left-right, back-front, up-down
	mountRotation = { 0, -3.18, 0  }; //- X= up-down , Y= roll-left-right , Z= left-right

	weaponType = 0; // Single Shot
	ammoType = MortarAmmo;
//	projectileType = MortarShell;
	accuFire = false;
	reloadTime = 0.5;
	fireTime = 2.0;

	lightType = 3;  // Weapon Fire
	lightRadius = 3;
	lightTime = 1;
	lightColor = { 0.6, 1, 1.0 };

	sfxFire = SoundMortarTurretFire;
	sfxActivate = SoundMortarTurretOn;
	sfxReload = SoundMortarTurretOff;
	sfxReady = SoundMortarTurretTurn;
};

ItemData Mortar
{
	description = "Mortar";
	className = "Weapon";
	shapeFile = "mortargun";
	hudIcon = "mortar";
   heading = "bWeapons";
	shadowDetailMask = 4;
	imageType = MortarImage;
	price = 375;
	showWeaponBar = true;
   validateShape = true;
};

//--------------------------------------

ItemImageData Mortar1Image
{
	shapeFile = "mortargun";
	mountPoint = 0; 
	mountOffset = { 0, 0, 0 }; //-  left-right, back-front, up-down
	mountRotation = { 0, 0, 0  }; //- X= up-down , Y= roll-left-right , Z= left-right
};

ItemData Mortar1
{
	description = "Mortar1";
	className = "weapon";
	shapeFile = "mortargun";
	shadowDetailMask = 4;
	imageType = Mortar1Image;
	showWeaponBar = false;
};

ItemImageData Mortar2Image
{
	shapeFile = "mortarammo";
	mountPoint = 0; 
	mountOffset = { 0, 0, -0.01  }; //-  left-right, back-front, up-down
	mountRotation = { 0, -3.18 , 0  }; //- X= up-down , Y= roll-left-right , Z= left-right
};

ItemData Mortar2
{
	description = "Mortar2";
	className = "weapon";
	shapeFile = "mortarammo";
	shadowDetailMask = 4;
	imageType = Mortar2Image;
	showWeaponBar = false;
};


function Mortar::onMount(%player,%item)
{
	Player::mountItem(%player, Mortar1, 5);
	Player::mountItem(%player, Mortar2, 6);
}

function Mortar::onUnMount(%player,%item)
{
	Player::unmountItem(%player, 5);
	Player::unmountItem(%player, 6);
}

function MortarImage::onFire(%player, %slot) 
{		
	if($debug)echo("?? EVENT fire "@Player::getMountedItem(%player,0)@ " player "@ %player @" cl# "@ Player::getclient(%player));	
	%client = GameBase::getOwnerClient(%player); 

	%jumpDir = Vector::getFromRot(GameBase::getRotation(%player), -200,10);
	Player::applyImpulse(%player,%jumpDir);

	Player::decItemCount(%player,Mortarammo,1); 
	%trans = GameBase::getMuzzleTransform(%player); 
	%vel = Item::getVelocity(%player); 
	Projectile::spawnProjectile("MortarShell1",%trans,%player,%vel,%player);
	Projectile::spawnProjectile("MortarShell2",%trans,%player,%vel,%player);
		
}